<blockSip>
  <block name="datatype_ByteArray">
  datatype ByteArray
  {
    SIZE:integer
    buff:string
  }
  </block>
  <block name="datatype_IntArray">
  datatype IntArray
  {
    SIZE:integer
    buff:string
  }
  </block>
  <block name="datatype_FloatArray">
  datatype FloatArray
  {
    SIZE:integer
    buff:string
  }
  </block>
  <block name="filter_GZIP">
  filter GZIP
  {
    in:ByteArray
    out:ByteArray
  }
  </block>
  <block name="filter_LZO">
  filter LZO
  {
    in:ByteArray
    out:ByteArray
  }
  </block>
  <block name="filter_SHRINK">
  filter SHRINK
  {
    in:ByteArray
    out:ByteArray
  }
  </block>
  <block name="filter_GREY">
  filter GREY
  {
    in:ByteArray
    out:ByteArray
  }
  </block>
  <block name="filter_JPEG">
  filter JPEG
  {
    in:ByteArray
    out:ByteArray
    param:integer
  }
  </block>
  <block name="filter_ENCRYPT">
  filter ENCRYPT
  {
    in:ByteArray
    out:ByteArray
  }
  </block>
  profile fps_profile
  <block name="pipe_Sender">
  pipe Sender
  {
    outports
    {
      out1:ByteArray
    }
  }
  </block>
  <block name="pipe_Receiver">
  pipe Receiver
  {
    inports
    {
      in1:ByteArray
    }
  }
  </block>
  <block name="composedPipe_UAV">
  composedPipe UAV
  {
    pipes
    {
      Sender:Sender
      Receiver:Receiver
    }
    connections
    {
      Sender.out1 -> Receiver.in1:fps_profile
    }
  }
  </block>
</blockSip>

