
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

//extern "C" {
#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include <stdio.h>
#include <string.h>
extern int cback();
//}
extern int pkt_rate_hist;
extern char haveLZO, haveGZIP, haveLossy, haveEncode, haveGrayscale, haveScale;
#define haveCompress (((haveLZO | haveGZIP)==0)?0:1)

// Values that encompass user preferences
extern char ifCompress, ifLossy, ifScale, ifGrayscale, ifEncode;
extern int target_fps;



int MAX_PKT_RATE=7; //7*16

gboolean
on_window_main_destroy           (GtkWidget       *widget,
                                        gpointer         user_data)
{
  gtk_exit(0);
  return FALSE;
}

/*
void
on_entry_fps_changed                   (GtkEditable     *editable,
                                        gpointer         user_data)
{
  gchar* entry;
  guint fps;
  printf(" [on_entry_fps_changed(): \n");
  entry = (gchar*)gtk_entry_get_text (GTK_ENTRY(editable));
  fps = atoi(entry);
  if (fps < 0 ) fps =0;
  else if (fps > MAX_PKT_RATE) fps = MAX_PKT_RATE;
  //The fps uses the 2nd byte in FILTER
  FILTER &= 0xFF00FFFF;
  FILTER |= fps<<16;
  printf("               new entry: (%s:%d)\n",entry, fps);
}
*/

void
on_button_user_require_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  printf(" [on_button_user_require_clicked(): \n");
	cback();

	return;
}


void
on_checkbutton_gzip_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if (gtk_toggle_button_get_active(togglebutton)) {
    printf(" [on_checkbutton_gzip_toggled(): togglebutton active.\n");
  	ifCompress = haveCompress;
	}
  else {
    printf(" [on_checkbutton_gzip_toggled(): togglebutton inactive.\n");
  	ifCompress = 0;
	}
}


void
on_checkbutton_shrink_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if (gtk_toggle_button_get_active(togglebutton)) {
    printf(" [on_checkbutton_shrink_toggled(): togglebutton active.\n");
  	ifScale = haveScale;
	}
  else {
    printf(" [on_checkbutton_shrink_toggled(): togglebutton inactive.\n");
  	ifScale = 0;
	}
}


void
on_checkbutton_grey_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if (gtk_toggle_button_get_active(togglebutton)) {
    printf(" [on_checkbutton_grey_toggled(): togglebutton active.\n");
  	ifGrayscale = haveGrayscale;
	}
  else {
    printf(" [on_checkbutton_grey_toggled(): togglebutton inactive.\n");
  	ifGrayscale = 0;
  }
}


void
on_checkbutton_jpeg_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if (gtk_toggle_button_get_active(togglebutton)) {
    printf(" [on_checkbutton_jpeg_toggled(): togglebutton active.\n");
  	ifLossy = haveLossy;
	}
  else {
    printf(" [on_checkbutton_jpeg_toggled(): togglebutton inactive.\n");
    ifLossy = 0;
  }
}


void
on_checkbutton_encrypt_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if (gtk_toggle_button_get_active(togglebutton)) {
    printf(" [on_checkbutton_encrypt_toggled(): togglebutton active.\n");
  	ifEncode = haveEncode;
	}
  else {
    printf(" [on_checkbutton_encrypt_toggled(): togglebutton inactive.\n");
    ifEncode = 0;
  }
}


void
on_checkbutton_flowCtrl_toggled         (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  if (gtk_toggle_button_get_active(togglebutton)) {
    printf(" [on_checkbutton_flowCtrl_toggled(): togglebutton active.\n");
  }
  else {
    printf(" [on_checkbutton_flowCtrl_toggled(): togglebutton inactive.\n");
  }
}


void
on_button_filter_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  printf(" [on_button_filter_clicked(): \n");

	cback();
	return;
}




/*
void on_combo_size_activated (GtkContainer* entry,
			      GtkDirectionType direction,
			       gpointer user_data)
{
  printf(" [on_combo_size_activated():\n");
  gchar* value = (gchar*)gtk_entry_get_text(GTK_ENTRY(entry));

  printf("                 value: >%s<\n", value);

  if (!strcmp(value, "Large: 320 x 240")) {
    UNSET_FILTER(SHRINK);
  }
  else if (!strcmp(value, "Small: 160 x 120")) {
    SET_FILTER(SHRINK);
  }
}
*/

/*
void on_combo_color_activated (GtkContainer* entry,
			       GtkDirectionType direction,
			       gpointer user_data)
{
  printf(" [on_combo_color_activated():\n");
  gchar* value = (gchar*)gtk_entry_get_text(GTK_ENTRY(entry));

  printf("                 value: >%s<\n", value);
  if (!strcmp(value, "Color")) {
    UNSET_FILTER(GREY);
  }
  else if (!strcmp(value, "Grey")) {
    SET_FILTER(GREY);
  }
}
*/

/*
void on_combo_compress_activated (GtkContainer* entry,
			       GtkDirectionType direction,
			       gpointer user_data)
{
  printf(" [on_combo_compress_activated():\n");
  gchar* value = (gchar*)gtk_entry_get_text(GTK_ENTRY(entry));

  printf("                 value: >%s<\n", value);
  if (!strcmp(value, "No")) {
    UNSET_FILTER(GZIP);
  }
  else if (!strcmp(value, "Yes")) {
    SET_FILTER(GZIP);
  }
}
*/


/*
void on_combo_lossy_activated (GtkContainer* entry,
			       GtkDirectionType direction,
			       gpointer user_data)
{
  printf(" [on_combo_lossy_activated():\n");
  gchar* value = (gchar*)gtk_entry_get_text(GTK_ENTRY(entry));

  printf("                 value: >%s<\n", value);
  if (!strcmp(value, "Yes")) {
    SET_FILTER(JPEG1);
  }
  else if (!strcmp(value, "No")) {
    UNSET_FILTER(JPEG1);
  }
  printf("              filter(%x) \n",FILTER);
}
*/


/*
void on_combo_security_activated (GtkContainer* entry,
			       GtkDirectionType direction,
			       gpointer user_data)
{
  printf(" [on_combo_security_activated():\n");
  gchar* value = (gchar*)gtk_entry_get_text(GTK_ENTRY(entry));

  printf("                 value: >%s<\n", value);
  if (!strcmp(value, "Yes")) {
    SET_FILTER(ENCRYPT);
  }
  else if (!strcmp(value, "No")) {
    UNSET_FILTER(ENCRYPT);
  }
  printf("              filter(%x) \n",FILTER);
}
*/


void
on_hscale_fps_value_changed     (GtkRange        *range,
                                        gpointer         user_data)
{
  printf(" [on_hscale_fps_value_changed(): \n");
  target_fps = gtk_range_get_value(range);

  if (target_fps < 0 ) target_fps = 1;
  else if (target_fps > MAX_PKT_RATE) target_fps = MAX_PKT_RATE;
  //The fps uses the 2nd byte in FILTER
  printf("               new fps: (%d)\n",target_fps);
}


guint on_measurement_update(gpointer data)
{
  char line[256] ;
  char filter_str[9];
  static int wc=0;
  static unsigned int last_last_seq_nr = 0;
  int nr;

  GtkTextIter    iter1, iter2;
  GTimeVal t;

  g_get_current_time (&t);
  GtkTextBuffer* gtb = gtk_text_view_get_buffer(GTK_TEXT_VIEW(textview_log));

  //Get the current iterator offset
  gtk_text_buffer_get_iter_at_offset(gtb, &iter1, wc);

  nr = sprintf(line, " Current FPS:%d\n", pkt_rate_hist );
	  
  gtk_text_buffer_insert (gtb, &iter1, line, nr);
  gtk_text_buffer_get_end_iter(gtb, &iter1);
  gtk_text_view_scroll_to_iter(GTK_TEXT_VIEW(textview_log), &iter1,
			       0,TRUE,0,0);

  wc+=nr;
  if (wc>= 3000) {
    gtk_text_buffer_get_start_iter(gtb, &iter1);
    gtk_text_buffer_get_end_iter(gtb, &iter2);
    gtk_text_buffer_delete(gtb, &iter1, &iter2);
    wc = 0;
  }

  return TRUE;
}




void
on_optionmenu_size_changed           (GtkOptionMenu   *optionmenu,
				      gpointer         user_data)
{
  gint i; 
  i = gtk_option_menu_get_history(optionmenu);
	if (0==i) 
    ifScale = 0;
  else if (1==i)
    ifScale = haveScale;

}

void
on_optionmenu_color_changed           (GtkOptionMenu   *optionmenu,
				      gpointer         user_data)
{
  gint i; 
  i = gtk_option_menu_get_history(optionmenu);
  if (0==i) 
    ifGrayscale = 0;
  else if (1==i)
    ifGrayscale = haveGrayscale;
}


void
on_optionmenu_compress_changed           (GtkOptionMenu   *optionmenu,
				      gpointer         user_data)
{
  gint i; 
  i = gtk_option_menu_get_history(optionmenu);
  if (0==i) 
    ifCompress = haveCompress;
  else if (1==i)
    ifCompress = 0;
}

void
on_optionmenu_lossy_changed           (GtkOptionMenu   *optionmenu,
				      gpointer         user_data)
{
  gint i; 
  i = gtk_option_menu_get_history(optionmenu);
  if (0==i) 
    ifLossy = haveLossy;
  else if (1==i)
    ifLossy = 0;
}


void
on_optionmenu_encrypt_changed           (GtkOptionMenu   *optionmenu,
				      gpointer         user_data)
{
  gint i; 
  i = gtk_option_menu_get_history(optionmenu);
  if (0==i) 
    ifEncode = haveEncode;
  else if (1==i)
    ifEncode = 0;
}

