#! /bin/bash

#find the newest python and do ln -s /usr/bin/newest_python /usr/bin/python2
#because in our python parser scripts we use fixed python2
#Require sudo under /usr/bin

search_path=/usr/bin
REQUEST_VERSION=2
python_list="
            `ls -r $search_path/python* 2>/dev/null`
	    "
#echo python_list: \{$python_list\}
python_prev_ver=0
for python_pkg in $python_list
do 
  python_this_ver=`echo $python_pkg | sed s/[a-zA-Z/-]*//`
  #echo $python_this_ver
  if [[ "$python_this_ver" > "$python_prev_ver" ]]
  then 
      python_prev_pkg=$python_pkg
      python_prev_ver=$python_this_ver
  fi
done

if [[ "$python_prev_ver" < "$REQUEST_VERSION" ]] 
then 
  @echo "Request Python version $REQUEST_VERSION"
else
  if [[ -n $python_prev_pkg ]]
  then 
   if [[ -f ${search_path}/python2 ]]
   then 
    sudo mv ${search_path}/python2 ${search_path}/python2.old
   fi

    sudo ln -s $python_prev_pkg ${search_path}/python2
  fi
fi



