#! /bin/bash
# Source this file to add or modify the PATH, LD_LIBRARY 
# variables, and to add the XERCESCROOT,XALANCROOT, and
# ACE+TAO variables

PATH=${PWD}/local/bin:$PATH

XERCESCROOT=${PWD}/tools/xerces-c1_7_0-linux7.2
XALANCROOT=${PWD}/tools/xml-xalan1_3/c

ACE_ROOT=
TAO_ROOT=$ACE_ROOT/TAO

if [[ -z $ACE_ROOT ]]
then
        echo "You need to set the ACE_ROOT in infopipes-env.sh, and re-source it"
fi

LD_LIBRARY_PATH=$XERCESCROOT/lib:$XALANCROOT/lib:${PWD}/local/lib:/usr/local/lib:$ACE_ROOT/ace:$TAO_ROOT/tao:$LD_LIBRARY_PATH

export PATH XERCESCROOT XALANCROOT LD_LIBRARY_PATH ACE_ROOT TAO_ROOT
