// Headers for dealing with XML
#include <util/PlatformUtils.hpp>
#include <sax/ErrorHandler.hpp>
#include <sax/SAXParseException.hpp>
#include <parsers/DOMParser.hpp>
// apparently must follow at least the util/PlatformUtils.hpp #include
#include <sax/SAXException.hpp>
#include <dom/DOM_DOMException.hpp>
#include <dom/DOM_NamedNodeMap.hpp>

// Other headers
#include <iostream.h>
#include <stdlib.h>
#include <stdarg.h>

/* Downcast from DOM_Node to DOM_Element */
DOM_Element DOM_ELEMENT(DOM_Node n);
/* stream out DOMString */
ostream &operator<<( ostream &out, DOMString s );
/* stream out DOM_Element tree in XML format */
ostream &operator<<( ostream &out, DOM_Element r );
ostream &operator<<( ostream &out, DOM_Document r );

// split document into files
int writeFiles( DOM_Document domDoc );
