<?xml version="1.0" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<!-- this is a mapping of the infopipe types -->
<xsl:variable name="maptables" select="document('ECho2mapTables.xml')/mapTables"/>

<xsl:template name="makeAll">
<xsl:for-each select="/xip/composedPipe">
<file>
<name><xsl:value-of select="@name"/>/Makefile</name>
<content>
CC = gcc
BASEPATH=/users/c/chaos
LIBPATH=$(BASEPATH)/lib/linux:$(ISG_TEMPLATE_PATH)
INCPATH=$(BASEPATH)/include
all:: <xsl:for-each select="declarations/pipe"><xsl:text> </xsl:text> <xsl:value-of select="@name"/> </xsl:for-each><xsl:text> 

</xsl:text>

<xsl:for-each select="declarations/pipe">
<xsl:value-of select="@name"/><thisNodeName/>::
	@echo Building <xsl:value-of select="@name"/>
	cd <xsl:value-of select="@name"/>; make; cd ..
</xsl:for-each><xsl:text>

</xsl:text>

</content> <xsl:text>
</xsl:text>
</file> <xsl:text>
</xsl:text>
</xsl:for-each>
</xsl:template>
</xsl:stylesheet>
