<blockSip>
  <block name="datatype_location">
  datatype location
  {
    address:string
    city:string
    state:string
    zipcode:string
  }
  </block>
  <block name="datatype_mapURL">
  datatype mapURL
  {
    url:string
    encoding:string
  }
  </block>
  <block name="datatype_mapImage">
  datatype mapImage
  {
    contentType:string
    contentTransferEncoding:string
    contentBody:string
  }
  </block>
  <block name="pipe_GetURLFromAddress">
  pipe GetURLFromAddress
  {
    inports
    {
      in1:location
    }
    outports
    {
      out1:mapURL
    }
  }
  </block>
  <block name="pipe_GetImageFromURL">
  pipe GetImageFromURL
  {
    inports
    {
      in1:mapURL
    }
    outports
    {
      out1:mapImage
    }
  }
  </block>
  <block name="pipe_ImageConverterToGray">
  pipe ImageConverterToGray
  {
    inports
    {
      in1:mapImage
    }
    outports
    {
      out1:mapImage
    }
  }
  </block>
  <block name="composedPipe_GetMap">
  composedPipe GetMap
  {
    pipes
    {
      GetMapUL:GetURLFromAddress
      GetMapImage:GetImageFromURL
      ImageConverterToGray:ImageConverterToGray
    }
    inports
    {
      in1:GetMapURL.in1
    }
    outports
    {
      out1:ImageConverterToGray.out1
    }
    connections
    {
      GetMapURL.out1 -> GetMapImage.in1
      GetMapImage.out1 -> ImageConverterToGray.in1
    }
  }
  </block>
</blockSip>

