
#include "output.hh"

/* Implementatin of class RawImageData. See output.hh.
   RawImageData is just a wrapper class for the PPM binary sequence */

RawImageData::RawImageData()
{
}

void RawImageData::Create(int width,int height)
{
  image.Create(width,height);
}

void RawImageData::CreateFromExistingMemory(Pixel* data,int width,int height)
{
  //Add sth. ?????????????
  image.CreateFromExistingMemory(data,width*3,height);
  //width*3 because each Pixel consists of 3 uint8, but Pixel is uint8
}

const Pixel*const* RawImageData::AskFrame_const() const
{
  return image.AskFrame_const();
}


