
#ifndef _CONTROLCENTERCLIENTWRAPPER_H
#define _CONTROLCENTERCLIENTWRAPPER_H

#include "ControlCenterC.h"

typedef enum filter_type_ {GZIP=0, LZO, SHRINK, GREY, JPEG1, JPEG2, JPEG3, ENCRYPT} filter_type;
#define SET_FILTER(i) (FILTER |= 1<<(i))
#define FILTER_GET(flag, i) ((flag) & 1<<(i))
#define UNSET_FILTER(i) ( FILTER_GET(FILTER, i)? FILTER ^= 1<<(i) : FILTER)


extern unsigned int FILTER;
extern "C" {
int init_ControlCenterC (int argc, char* argv[]);
}

extern CORBA::ORB_var orb;
extern ControlCenter_ptr server;

#endif
