#!/bin/sh

./clean.sh

DIR=/tmp/infopipes-6-24-2003/demos/UAV2/AV_gen
HOSTNAME=localhost

ARGS=$*

HOSTNAME=`hostname`
xterm -e $ACE_ROOT/TAO/orbsvcs/Naming_Service/Naming_Service -ORBEndpoint iiop://$HOSTNAME:2809 &

sleep 2
cd $DIR


xterm -e ./SenderMonitorServer -ORBEndpoint iiop://$HOSTNAME:0 -ORBInitRef NameService=corbaloc::$HOSTNAME:2809/NameService &
sleep 2

xterm -e ./Receiver -ORBEndpoint iiop://$HOSTNAME:0 -ORBInitRef NameService=corbaloc::$HOSTNAME:2809/NameService &

sleep 2
xterm -e ./ReceiverMonitorClient -ORBEndpoint iiop://$HOSTNAME:0 -ORBInitRef NameService=corbaloc::$HOSTNAME:2809/NameService &

# Sender can either reads PPM image from the sample PPM files or from USB Video Camera.
# `-f' in cammand line option means reading from file. Remove it if you want to read from live camera.
sleep 2
xterm -e ./Sender -ORBEndpoint iiop://$HOSTNAME:0 -ORBInitRef NameService=corbaloc::$HOSTNAME:2809/NameService -n 0 -f &




