<?xml version="1.0" ?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:output method="xml"/>

<!-- this is a mapping of the infopipe types -->
<xsl:variable name="maptables" select="document('ECho2mapTables.xml')/mapTables"/>
    <xsl:include href="ECho2allHeader.xsl"/> 
    <xsl:include href="ECho2makeAll.xsl"/>
    <xsl:include href="ECho2makeOne.xsl"/>
    <xsl:include href="ECho2oneHeader.xsl"/>
    <xsl:include href="ECho2oneSource.xsl"/>
<!--
-->
<xsl:template match="/xip">
  <filledTemplate>
    <xsl:call-template name="allHeader"/>
    <xsl:call-template name="makeAll"/>
    <xsl:call-template name="makeOne"/>
    <xsl:call-template name="oneHeader"/>
    <xsl:call-template name="oneSource"/>
    <!--
    -->
    <!--
    -->
    <!-- 
    <xsl:include href="ECho2testDriver.xsl"/>
    -->
  </filledTemplate>
</xsl:template>
  
</xsl:stylesheet>
