/*
 * @author Wenchang Yan
 * @time Dec, 2001
 */

/* For TCP/UDP connection creation */
#include <sys/types.h>

extern int tprintf(const char* fmt, ...);

/* socket creation */
int socket_create(const char* host, int port, const char* transport);
int connect_udp(const char* host, int port);
int connect_tcp(const char* host, int port);
void set_server(struct sockaddr_in* server, int addr, int port); 
