
#ifndef _DIALOG_SHOW_FILE_H
#define _DIALOG_SHOW_FILE_H

#include <gtk/gtk.h>
#include <stdio.h>
#include "const.h"

/* the current blk nr of the clicked area.
 * value of -1 means the clicked area is not a block region of interest
 */
/* Obsolete */
//extern guint CUR_BLK_NR;
extern gchar* CUR_BLK_NAME;




#if 0
/* Get the blk_nr from the cursor position in the text widget*/
guint get_blk_nr_from_cursor(GtkWidget* text, int pos);
/* Get a list of matched block_info from the blk_nr */
GList* get_blk_info_from_blk_nr(GtkWidget* text, guint blk_nr);
/* Redraw all the texts in all the related windows*/
void redisplay_all_blk(guint blk_nr);
gboolean line_in_blk(guint line_nr, GList* matched_blk_info_list);
#endif





/* Get the blk_name from the cursor position in the text widget*/
gchar* get_blk_name_from_cursor(GtkWidget* text, int pos);

/* Get a list of matched block_info from the blk_name */
GList* get_blk_info_from_blk_name(GtkWidget* text, gchar* blk_name);

/* Redraw all the texts in all the related windows*/
void redisplay_all_blk(gchar* blk_name);


void redisplay_SIP_blk(GtkWidget* text, GList* matched_blk_info_list);

void redisplay_XIP_blk(GtkWidget* text, GList* matched_blk_info_list);

void redisplay_gencode_blk(GtkWidget* text, GList* matched_blk_info_list);

/* Used to underscore the gencode notebook page label to indicate
   this notebook page has been highlighted */
void reset_gencode_notebook_page_label(gboolean highlight, 
				       GtkWidget* text_view);

gboolean word_in_blk(guint offset, GList* matched_blk_info_list);


void  change_space_to_bracket_in_XIP(GtkWidget* text);
///////////////
//
gboolean on_dialog_show_file_text_delete_event(GtkEditable* widget,
                                        gint             start_pos,
                                        gint             end_pos,
					       gpointer         user_data);

gboolean on_dialog_show_file_text_move_cursor_event(GtkEditable* widget,
                                        gint             x,
                                        gint             y,
						    gpointer         user_data);

//
///////
gboolean on_dialog_show_file_text_button_press(GtkWidget* widget,
					   GdkEventButton* event,
					   gpointer data);

//GtkWidget* create_dialog_show_file (void);
GtkWidget* create_dialog_show_file(gchar* filename, gint x, gint y, 
			    GtkWidget** dialog_show_file_text,
				   GtkTextBuffer** dialog_show_file_text_buf,
				   char* text_widget_name);


gboolean
on_dialog_show_file_delete_event       (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_close_button_clicked                (GtkButton       *button,
                                        gpointer         user_data);

void
on_close_all_dialog_button_clicked  (GtkButton       *button,
				     gpointer         user_data);


gboolean
on_dialog_show_file_text_focus_in_event
                                        (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data);



#endif
